| Disk ARchive 2.7.18 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
libdar::generic_rsync Class Reference
Private

generic_file interface to librsync More...

`#include <generic_rsync.hpp>`

Inherits libdar::generic_file.

## Public Member Functions
| generic_rsync (generic_file *signature_storage, U_I signature_block_size, generic_file *below)
| constructor for "signature" operation
| generic_rsync (generic_file *base_signature, generic_file *below, const infinint &crc_size, const crc **checksum)
| constructor for "delta" operation
| generic_rsync (generic_file *current_data, generic_file *delta)
| constructor for "patch" operation
| generic_rsync (const generic_rsync &ref)=delete
| generic_rsync (generic_rsync &&ref) noexcept=delete
generic_rsync & | operator= (const generic_rsync &ref)=delete
generic_rsync & | operator= (generic_rsync &&ref) noexcept=delete
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const

## Private Types
enum | { sign , delta , patch }

## Private Member Functions
bool | step_forward (const char *buffer_in, U_I &avail_in, bool shift_input, char *buffer_out, U_I &avail_out)
| feed librsync using rs_job_iter
void | free_job ()
void | send_eof ()

## Private Attributes
enum libdar::generic_rsync:: { ... } | status
generic_file * | x_below
| underlying layer to read from / write to
generic_file * | x_input
generic_file * | x_output
bool | initial
char * | working_buffer
U_I | working_size
bool | patching_completed
crc * | data_crc

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }

## Detailed Description

generic_file interface to librsync

Definition at line 50 of file generic_rsync.hpp.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| private

Definition at line 120 of file generic_rsync.hpp.

## Constructor & Destructor Documentation

## ◆ generic_rsync() [1/3]

libdar::generic_rsync::generic_rsync | ( | generic_file * | signature_storage,
|  | U_I | signature_block_size,
|  | generic_file * | below )

constructor for "signature" operation

in this mode the generic_rsync object is read only, all data read from it is fetched unchanged from "below" while the signature is computed. The file signature is output to signature_storage

Parameters

  [in] | signature_storage | is write only mode generic_file
  [in] | signature_block_size | the block len to use to build the signature
  [in] | below | is read only to fetch data from

## ◆ generic_rsync() [2/3]

libdar::generic_rsync::generic_rsync | ( | generic_file * | base_signature,
|  | generic_file * | below,
|  | const infinint & | crc_size,
|  | const crc ** | checksum )

constructor for "delta" operation

in this mode the generic_rsync object is also read only, all data read from it is the resulting delta of the data read from "below" based the given base_signature.

Parameters

  [in] | base_signature | is read only
  [in] | below | is the plain file to read from and for which to compute the delta based on base_signature
  [in] | crc_size | is the size of the crc to create if checksum is not nullptr
  [in] | checksum | if not null, the *checksum will be set to the address of a newly allocated crc that will receive the calculated crc of the below object, this CRC is calcuated for the data of "below". Caller has the duty to release this object when no more needed but never before this generic_rsync object has been destroyed.

## ◆ generic_rsync() [3/3]

libdar::generic_rsync::generic_rsync | ( | generic_file * | current_data,
|  | generic_file * | delta )

constructor for "patch" operation

in this mode the generic_rsync object is read only, the data read from it is built from the current file's data and the delta signature.

Parameters

  [in] | current_data | is a read_only object that contains the data to be used as base for the patch (this data is not modified)
  [in] | delta | is read only and contains the patch to apply

## Member Function Documentation

## ◆ get_position()

virtual infinint libdar::generic_rsync::get_position | ( |  | ) | const
| inline override virtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 108 of file generic_rsync.hpp.

References libdar::generic_file::get_position(), and x_below.

Referenced by inherited_truncate(), and truncatable().

## ◆ inherited_flush_read()

virtual void libdar::generic_rsync::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 116 of file generic_rsync.hpp.

## ◆ inherited_read()

virtual U_I libdar::generic_rsync::inherited_read | ( | char * | a,
|  | U_I | size )
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::generic_rsync::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 111 of file generic_rsync.hpp.

## ◆ inherited_sync_write()

virtual void libdar::generic_rsync::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 115 of file generic_rsync.hpp.

## ◆ inherited_terminate()

virtual void libdar::generic_rsync::inherited_terminate | ( |  | ) |
| override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

## ◆ inherited_truncate()

virtual void libdar::generic_rsync::inherited_truncate | ( | const infinint & | pos | ) |
| inline override protected virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

Definition at line 114 of file generic_rsync.hpp.

References get_position().

## ◆ inherited_write()

virtual void libdar::generic_rsync::inherited_write | ( | const char * | a,
|  | U_I | size )
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ skip()

virtual bool libdar::generic_rsync::skip | ( | const infinint & | pos | ) |
| inline override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

Definition at line 104 of file generic_rsync.hpp.

## ◆ skip_relative()

virtual bool libdar::generic_rsync::skip_relative | ( | S_I | x | ) |
| inline override virtual

skip relatively to the current position

Implements libdar::generic_file.

Definition at line 106 of file generic_rsync.hpp.

## ◆ skip_to_eof()

virtual bool libdar::generic_rsync::skip_to_eof | ( |  | ) |
| inline override virtual

skip to the end of file

Implements libdar::generic_file.

Definition at line 105 of file generic_rsync.hpp.

## ◆ skippable()

virtual bool libdar::generic_rsync::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| inline override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 103 of file generic_rsync.hpp.

## ◆ step_forward()

bool libdar::generic_rsync::step_forward | ( | const char * | buffer_in,
|  | U_I & | avail_in,
|  | bool | shift_input,
|  | char * | buffer_out,
|  | U_I & | avail_out )
| private

feed librsync using rs_job_iter

Parameters

  [in] | buffer_in | bytes of data to give to librsync
  [in,out] | avail_in | is the amount of byte available, and after the call the amount of not yet read bytes remaining at the beginning of the buffer_in buffer (when shift_input is set to true) or at the end of buffer_in if shift is set to false.
  [in] | shift_input |
  [out] | buffer_out | where to drop the data from librsync
  [in,out] | avail_out | is the size of the allocated memory pointed to by buffer_out and after the call the amount of byte that has been dropped to the buffer_out buffer.

Returns
  true if librsync returned RS_DONE else false is return if RS_BLOCKED is returned. For any other errors an exception is thrown

## ◆ truncatable()

virtual bool libdar::generic_rsync::truncatable | ( | const infinint & | pos | ) | const
| inline override virtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 107 of file generic_rsync.hpp.

References get_position().

## Member Data Documentation

## ◆ data_crc

crc* libdar::generic_rsync::data_crc
| private

Definition at line 129 of file generic_rsync.hpp.

## ◆ initial

bool libdar::generic_rsync::initial
| private

Definition at line 125 of file generic_rsync.hpp.

## ◆ patching_completed

bool libdar::generic_rsync::patching_completed
| private

Definition at line 128 of file generic_rsync.hpp.

## ◆ working_buffer

char* libdar::generic_rsync::working_buffer
| private

Definition at line 126 of file generic_rsync.hpp.

## ◆ working_size

U_I libdar::generic_rsync::working_size
| private

Definition at line 127 of file generic_rsync.hpp.

## ◆ x_below

generic_file* libdar::generic_rsync::x_below
| private

underlying layer to read from / write to

Definition at line 122 of file generic_rsync.hpp.

Referenced by get_position().

## ◆ x_input

generic_file* libdar::generic_rsync::x_input
| private

Definition at line 123 of file generic_rsync.hpp.

## ◆ x_output

generic_file* libdar::generic_rsync::x_output
| private

Definition at line 124 of file generic_rsync.hpp.

The documentation for this class was generated from the following file:

- generic_rsync.hpp